<?php

class Router {

	private $controller;
	private $action;
	private $file;
	private $registry;

	public function __construct(Registry $registry) {
		$this->registry = $registry;
	}


	
	// tato metoda provede vlastni routovani na zaklade ziskanych parametru
	public function route() {
		// zjistime si, co od nas kdo chce
		$this->getControllerInfo();
		

		//overime, zda dany controller existuje
		if (is_readable("controllers/".$this->file) == false)
		{
			//  a pokud ne, tak zvolime jeden specializovany controller
			// urceny pro nahlaseni chyby 404
			$this->file = 'error404.php';
			$this->controller = 'error404';
		}

		// ted muzeme includnout ten controller, o ktery slo
		include "controllers/".$this->file;

		// vyrobime jeho instanci
		$class = $this->controller . 'Controller';
		$controller = new $class($this->registry);

		// ted zjistime, jestli tento controller ma pozadovanou akci, tedy metodu
		// a pokud ne, zavolame metodu (tedy akci) index
		if (is_callable(array($controller, $this->action)) == false)
		{
			$action = 'index';
		}
		else
		{
			$action = $this->action;
		}
		/*** run the action ***/
		$controller->$action();

	}



	// metoda vezme parametr rt a zjisti z nej
	// akci a dalsi parametry

	protected function getControllerInfo() {
		$route = (empty($_GET['rt'])) ? '' : $_GET['rt'];

		if (empty($route))
		{
			$route = 'index';
		}
		else
		{
			/*** get the parts of the route ***/
			$parts = explode('/', $route);
			$this->controller = $parts[0];
			if(isset( $parts[1]))
			{
				$this->action = $parts[1];
			}
		}

		if (empty($this->controller))
		{
			$this->controller = 'index';
		}

		/*** Get action ***/
		if (empty($this->action))
		{
			$this->action = 'index';
		}

		/*** set the file path ***/
		$this->file = $this->controller . '.php';
	}
}



?>